#include "mbed.h"
#include "I2CLCD.h"
//#define INVADER

#ifndef INVADER
int main()
{
   I2CLCD lcd(p28,p27);
   int i=0;
    printf("LCD test\n");
    while(true)
    {
        lcd.write("*** LCD Test ***");
        lcd.write("M.Mizuno");
        lcd.write(i++,8,0);
        wait(0.2);
        lcd.clear();
    }
}

#else
int main()
{
  I2CLCD display(p28,p27);
  display.clear();
  display.write("LCD ̨ý");
  wait_ms(1500);

  unsigned int invader[8] = {0x104, 0x88, 0x1fc, 0x376, 0x7ff, 0x5fd, 0x5f5, 0xd8};
  unsigned int invader2[8]= {0x104, 0x489, 0x5fd, 0x777, 0x7ff, 0x3fe, 0x104,0x202};
  unsigned int tako[8] = {0xf0,0x7fe,0xfff,0xe67,0xfff,0x198,0x36c,0xc03};
  unsigned int ufo[8] = {0x60,0x1f8,0x3fc,0x6f6,0xfff,0x39c,0x108,0};
  unsigned int ika[8] = {0x18,0x3c,0x7e,0xdb,0xff,0x24,0x5a,0xa5};
  unsigned int *inv, count=0;
  unsigned char cgData[64];
  int i, j, k, m=0, n=0, x=0;

  for(i=3; i<8; i++) {
     for(j=0; j<8; j++) cgData[i*8+j]=0;
  }
  inv = ufo;
  while(true)
  {
    for(k=0; k<14; k++) {
      n = 0;
      for(m=0; m<6; m++) {
        switch(count % 4) {
          case 3: inv = ika;  break;
          case 2: inv = ufo;  break;
          case 1: inv = tako; break;
          case 0:
                  if((x++ % 4)<2) inv = invader;
                  else inv = invader2;
        }
        for(i=0; i<8; i++) cgData[i]    = (inv[i]>>(6+m));
        for(i=0; i<8; i++) cgData[i+8]  = ((inv[i]>>m) & 0x1f);
        for(i=0; i<8; i++) cgData[i+16] = ((inv[i] & n)<<(6-m));
        n = n*2+1;

        display.setCG(1, (char*)cgData);
        display.write(0x00,0x80);
        for(j=0; j<k; j++) display.write(0x40, 3);
        for(j=0; j<3; j++) display.write(0x40, j);
        for(j=k+3; j<16; j++) display.write(0x40, 3);
        wait_ms(100);
      }    // m
    } // k
    count++;
  } // while
}
#endif
